CREATE OR REPLACE
PROCEDURE USR_NECESSIDADE_DE_AGENDA_OL( P_NRAGENDAOL    IN GRSAGENDAOL.NRAGENDAOL%TYPE,
                                        P_CDFORNECED    IN FORNECEDOR.CDFORNECED%TYPE,
                                        P_DTINICIAL     IN DATE,
                                        P_DTFINAL       IN DATE,
                                        P_CDPRODINI     IN PRODUTO.CDARVPROD%TYPE,
                                        P_CDPRODFIN     IN PRODUTO.CDARVPROD%TYPE,
                                        P_IDAFPERIODO   IN VARCHAR2,
                                        P_PEACRESCIMO   IN NUMBER,
                                        P_LISTAMES      IN VARCHAR,
                                        P_CDOPERADOR    IN OPERADOR.CDOPERADOR%TYPE,
                                        P_ROWSAFFECT    OUT VARCHAR2
                                       )
AS
   V_CDPRODINI        PRODUTO.CDARVPROD%TYPE;
   V_CDPRODFIN        PRODUTO.CDARVPROD%TYPE;
   V_CDFORNOL         FORNECEDOR.CDFORNECED%TYPE;
   V_CDPRODUTO        PRODUTO.CDPRODUTO%TYPE := 'XXXXXXXXXX';
   V_CDMARCA          MARCA.CDMARCA%TYPE     := 'XXXXX';
   V_DTENTREGAGENDA   DATE;
   V_VRPREUNIAGENDA   FLOAT;
   V_QTPROGENTAF      FLOAT;
   V_NOVADATA         DATE;
   V_QTPOSESTOL       POSESTOL.QTPOSESTOL%TYPE := 0;
   V_QTENTREGAGENDA   POSESTOL.QTPOSESTOL%TYPE := 0;
   V_QTPREVITMFORNOL  GRSITEMAGENDAOL.QTPREVITMFORNOL%TYPE := 0;
   V_DTENTREGANT      DATE;
   V_QTAFPERIODO      FLOAT;
   V_QTAVGPROGENT     FLOAT;
   V_VRDIAS           FLOAT;
   V_QTPROGITMFORNOL  FLOAT;
   V_QTDISPOFORNOL    FLOAT;
   V_QTESTOQUE        FLOAT := 0;
BEGIN
   P_ROWSAFFECT := 'N';
   IF P_CDPRODINI > P_CDPRODFIN THEN
      V_CDPRODINI := RPAD(P_CDPRODINI, 20, 'Z');
      V_CDPRODFIN := P_CDPRODFIN;
   ELSE
      V_CDPRODFIN := RPAD(P_CDPRODFIN, 20, 'Z');
      V_CDPRODINI := P_CDPRODINI;
   END IF;
   SELECT NVL(COUNT(*), 0)
     INTO V_QTESTOQUE
     FROM POSESTOL
    WHERE CDFORNECED = P_CDFORNECED
      AND DTPOSESTOL = TRUNC(SYSDATE);
   IF V_QTESTOQUE > 0 THEN
      INSERT
        INTO GRSAGENDAOL(NRAGENDAOL, CDFORNECED, DTINIVAGENDAOL, DTFINVAGENDAOL, CDPRODINIOL,
                         CDPRODFINOL, DTAGENDAOL, IDAFPERIODO, VRACRESCIMO, DSLISTAMES,
                         CDOPERADOR)
      VALUES (P_NRAGENDAOL, P_CDFORNECED, P_DTINICIAL, P_DTFINAL, P_CDPRODINI,
              P_CDPRODFIN, SYSDATE, P_IDAFPERIODO, P_PEACRESCIMO, P_LISTAMES,
              P_CDOPERADOR);

      IF P_IDAFPERIODO  = 'S' THEN
         FOR C_ITEM IN (SELECT A.CDFORNECED, I.CDPRODUTO, I.DTPROGENTAF, SUM(QTPROGENTAF) QTPROGENTAF, I.CDMARCA
                          FROM AUTOFORNE A, ITEMAUTF I, PRODUTO P
                         WHERE A.CDFORNECED  = P_CDFORNECED
                           AND I.CDFILDEST   = A.CDFILDEST
                           AND I.CDFILLANC   = A.CDFILLANC
                           AND I.NRAUTOFORN  = A.NRAUTOFORN
                           AND I.CDPRODUTO   = P.CDPRODUTO
                           AND NVL(I.QTPROGENTAF, 0) > 0
                           AND I.DTPROGENTAF BETWEEN P_DTINICIAL AND P_DTFINAL
                           AND P.CDARVPROD BETWEEN V_CDPRODINI AND V_CDPRODFIN
                         GROUP BY A.CDFORNECED, I.CDPRODUTO, I.DTPROGENTAF, I.CDMARCA
                         ORDER BY I.CDPRODUTO, I.DTPROGENTAF, I.CDMARCA)
         LOOP
            V_DTENTREGAGENDA   := NULL;
            V_VRPREUNIAGENDA   := 0;
            FOR C_ITEM_MARCA
             IN (SELECT I.CDMARCA, NVL(MAX(I.CDFORNOL), '') CDFORNOL, NVL(MIN(I.VRPRECUNIITM), 0) VRPRECUNIITM, I.QTDISPOFORNOL
                   FROM GRSITMCOLFORNOL I, GRSPARAMFORNOL P
                  WHERE I.CDFORNOL   = P.CDFORNOL
                    AND I.CDFORNECED = P.CDFORNECED
                    AND I.CDFORNECED = P_CDFORNECED
                    AND I.CDPRODUTO  = C_ITEM.CDPRODUTO
                    AND I.CDMARCA    = C_ITEM.CDMARCA
                    AND I.DTINVAFORNOL >= P_DTINICIAL
                    AND I.DTFIVAFORNOL <= P_DTFINAL
                    AND P.HRENTRFORNOL IS NOT NULL
                    AND ((IDDOMFORNOL IS NOT NULL)
                     OR (IDSEGFORNOL  IS NOT NULL)
                     OR (IDTERFORNOL IS NOT NULL)
                     OR (IDQUAFORNOL IS NOT NULL)
                     OR (IDQUIFORNOL IS NOT NULL)
                     OR (IDSEXFORNOL IS NOT NULL)
                     OR (IDSABFORNOL IS NOT NULL))
                   -- AND C_ITEM.DTPROGENTAF BETWEEN I.DTINVAFORNOL AND I.DTFIVAFORNOL
                    AND I.VRPRECUNIITM = (SELECT MIN(IT.VRPRECUNIITM)
                                            FROM GRSITMCOLFORNOL IT
                                           WHERE IT.CDFORNECED   = I.CDFORNECED
                                             AND IT.CDPRODUTO    = I.CDPRODUTO
                                             AND IT.DTINVAFORNOL = I.DTINVAFORNOL
                                             AND IT.DTFIVAFORNOL = I.DTFIVAFORNOL)
                                             /*COLOCAR CONSIO PARA CONSIDERA ESTOQUE DIPONVEL SE NECESSRIO */
                  GROUP BY  I.CDMARCA, I.QTDISPOFORNOL)
            LOOP
               V_QTPROGENTAF := C_ITEM.QTPROGENTAF;
               V_QTPROGENTAF := V_QTPROGENTAF* (1 + (P_PEACRESCIMO/100));
               SELECT USR_CARREGA_PERIFORNOL_FUN(P_CDFORNECED, C_ITEM_MARCA.CDFORNOL, C_ITEM.DTPROGENTAF)
                 INTO V_DTENTREGAGENDA
                 FROM DUAL;
               /*COMO O OL CONTROLA ESTOQUE DOS ITENS*/
               IF V_CDPRODUTO||V_CDMARCA <> C_ITEM.CDPRODUTO||C_ITEM.CDMARCA THEN
                  V_CDPRODUTO := C_ITEM.CDPRODUTO;
                  V_CDMARCA   := C_ITEM.CDMARCA;
                  SELECT NVL(MAX(QTPOSESTOL), 0)
                    INTO V_QTPOSESTOL
                    FROM POSESTOL
                   WHERE CDFORNECED = P_CDFORNECED
                     AND CDPRODUTO  = C_ITEM.CDPRODUTO
                     AND CDMARCA    = C_ITEM.CDMARCA
                     AND DTPOSESTOL = TRUNC(SYSDATE);    /*tratar data de processamento*/
                  V_QTESTOQUE := V_QTPOSESTOL;
               END IF;
               V_QTENTREGAGENDA  := V_QTPROGENTAF;
               V_QTPROGITMFORNOL := 0;
               IF V_QTPOSESTOL > 0 THEN
                  IF V_QTPOSESTOL >= V_QTPROGENTAF THEN
                     V_QTPROGITMFORNOL := V_QTPROGENTAF;
                     V_QTPOSESTOL      := V_QTPOSESTOL - V_QTPROGENTAF;
                  END IF;
               END IF;
               IF V_QTPOSESTOL < 0 THEN
                  V_QTPOSESTOL      := 0;
               END IF;
               SELECT NVL(SUM(QTPREVITMFORNOL), 0)
                 INTO V_QTPREVITMFORNOL
                 FROM GRSITEMAGENDAOL
                WHERE CDFORNECED     = P_CDFORNECED
                  AND CDPRODUTO      = C_ITEM.CDPRODUTO
                  AND CDMARCA        = C_ITEM.CDMARCA
                  AND DTENTREGAGENDA = V_DTENTREGAGENDA;
               V_QTENTREGAGENDA  := V_QTENTREGAGENDA; /*VERIFICAR ESSA CONDIO  - V_QTPREVITMFORNO*/
               IF V_QTENTREGAGENDA > 0 THEN
                  BEGIN
                     INSERT
                       INTO GRSITEMAGENDAOL(NRAGENDAOL, CDFORNECED, CDFORNOL, CDPRODUTO, CDMARCA, DTENTREGAGENDA, VRPREUNIAGENDA,
                                            QTPREVITMFORNOL, QTPROGITMFORNOL, QTDISPOFORNOL, QTESTOQFORNOL)
                     VALUES (P_NRAGENDAOL, P_CDFORNECED, C_ITEM_MARCA.CDFORNOL, C_ITEM.CDPRODUTO, C_ITEM_MARCA.CDMARCA, V_DTENTREGAGENDA, C_ITEM_MARCA.VRPRECUNIITM,
                            V_QTENTREGAGENDA, V_QTPROGITMFORNOL, C_ITEM_MARCA.QTDISPOFORNOL, V_QTESTOQUE);
                  EXCEPTION
                     WHEN OTHERS THEN
                        UPDATE GRSITEMAGENDAOL
                           SET QTPREVITMFORNOL = QTPREVITMFORNOL+V_QTENTREGAGENDA,
                               QTPROGITMFORNOL = QTPROGITMFORNOL+V_QTPROGITMFORNOL,
                               QTDISPOFORNOL   = C_ITEM_MARCA.QTDISPOFORNOL,
                               QTESTOQFORNOL   = V_QTESTOQUE
                         WHERE NRAGENDAOL     = P_NRAGENDAOL
                           AND CDFORNECED     = P_CDFORNECED
                           AND CDFORNOL       = C_ITEM_MARCA.CDFORNOL
                           AND CDPRODUTO      = C_ITEM.CDPRODUTO
                           AND CDMARCA        = C_ITEM_MARCA.CDMARCA
                           AND DTENTREGAGENDA = V_DTENTREGAGENDA;
                  END;
                  P_ROWSAFFECT := 'S';
               END IF;
            END  LOOP;
         END LOOP;
      ELSE
         FOR C_ITEM IN (SELECT DISTINCT A.CDFORNECED, I.CDPRODUTO, I.CDMARCA
                          FROM AUTOFORNE A, ITEMAUTF I, PRODUTO P
                         WHERE A.CDFORNECED  = P_CDFORNECED
                           AND I.CDFILDEST   = A.CDFILDEST
                           AND I.CDFILLANC   = A.CDFILLANC
                           AND I.NRAUTOFORN  = A.NRAUTOFORN
                           AND I.CDPRODUTO   = P.CDPRODUTO
                           AND NVL(I.QTPROGENTAF, 0) > 0
                           AND INSTR(P_LISTAMES, TO_CHAR(I.DTPROGENTAF, 'MM/YYYY')) > 0
                           AND P.CDARVPROD BETWEEN V_CDPRODINI AND V_CDPRODFIN
                         ORDER BY A.CDFORNECED, I.CDPRODUTO, I.CDMARCA)
         LOOP
            FOR C_ITEM_MARCA
             IN (SELECT I.CDMARCA, NVL(MAX(I.CDFORNOL), '') CDFORNOL, NVL(MIN(I.VRPRECUNIITM), 0) VRPRECUNIITM, I.QTDISPOFORNOL
                   FROM GRSITMCOLFORNOL I, GRSPARAMFORNOL P
                  WHERE I.CDFORNOL   = P.CDFORNOL
                    AND I.CDFORNECED = P.CDFORNECED
                    AND I.CDFORNECED = P_CDFORNECED
                    AND I.CDPRODUTO  = C_ITEM.CDPRODUTO
                    AND I.CDMARCA    = C_ITEM.CDMARCA
                    AND I.DTINVAFORNOL >= P_DTINICIAL
                    AND I.DTFIVAFORNOL <= P_DTFINAL
                    AND P.HRENTRFORNOL IS NOT NULL
                    AND ((IDDOMFORNOL IS NOT NULL)
                     OR (IDSEGFORNOL  IS NOT NULL)
                     OR (IDTERFORNOL IS NOT NULL)
                     OR (IDQUAFORNOL IS NOT NULL)
                     OR (IDQUIFORNOL IS NOT NULL)
                     OR (IDSEXFORNOL IS NOT NULL)
                     OR (IDSABFORNOL IS NOT NULL))
                   -- AND C_ITEM.DTPROGENTAF BETWEEN I.DTINVAFORNOL AND I.DTFIVAFORNOL
                    AND I.VRPRECUNIITM = (SELECT MIN(IT.VRPRECUNIITM)
                                            FROM GRSITMCOLFORNOL IT
                                           WHERE IT.CDFORNECED   = I.CDFORNECED
                                             AND IT.CDPRODUTO    = I.CDPRODUTO
                                             AND IT.DTINVAFORNOL = I.DTINVAFORNOL
                                             AND IT.DTFIVAFORNOL = I.DTFIVAFORNOL)
                  GROUP BY  I.CDMARCA, I.QTDISPOFORNOL)
            LOOP
               SELECT COUNT(*)
                 INTO V_VRDIAS
                 FROM DATA
                WHERE DTDATA BETWEEN P_DTINICIAL AND P_DTFINAL
                  AND DTDATA = USR_CARREGA_PERIFORNOL_FUN(P_CDFORNECED, C_ITEM_MARCA.CDFORNOL, DTDATA);
               SELECT CEIL(AVG(QTPROGENTAF)/V_VRDIAS)
                 INTO V_QTAVGPROGENT
                 FROM AUTOFORNE A, ITEMAUTF I
                WHERE A.CDFORNECED  = P_CDFORNECED
                  AND I.CDFILDEST   = A.CDFILDEST
                  AND I.CDFILLANC   = A.CDFILLANC
                  AND I.NRAUTOFORN  = A.NRAUTOFORN
                  AND I.CDMARCA     = C_ITEM_MARCA.CDMARCA
                  AND I.CDPRODUTO   = C_ITEM.CDPRODUTO
                  AND INSTR(P_LISTAMES, TO_CHAR(I.DTPROGENTAF, 'MM/YYYY')) > 0;
               IF V_QTAVGPROGENT > 0 THEN
                  FOR C_ITEM_AVG
                   IN (SELECT DISTINCT USR_CARREGA_PERIFORNOL_FUN(P_CDFORNECED, C_ITEM_MARCA.CDFORNOL, DTDATA) DTPROGENT
                         FROM DATA
                        WHERE DTDATA BETWEEN P_DTINICIAL AND P_DTFINAL
                        ORDER BY DTPROGENT)
                  LOOP
                     V_QTPROGENTAF := V_QTAVGPROGENT;
                     /*COMO O OL CONTROLA ESTOQUE DOS ITENS*/
                     IF V_CDPRODUTO||V_CDMARCA <> C_ITEM.CDPRODUTO||C_ITEM.CDMARCA THEN
                        V_CDPRODUTO := C_ITEM.CDPRODUTO;
                        V_CDMARCA   := C_ITEM.CDMARCA;
                        SELECT NVL(MAX(QTPOSESTOL), 0)
                          INTO V_QTPOSESTOL
                          FROM POSESTOL
                         WHERE CDFORNECED = P_CDFORNECED
                           AND CDPRODUTO  = C_ITEM.CDPRODUTO
                           AND CDMARCA    = C_ITEM.CDMARCA
                           AND DTPOSESTOL = TRUNC(SYSDATE);
                        V_QTESTOQUE := V_QTPOSESTOL;
                     END IF;
                     SELECT NVL(SUM(QTPREVITMFORNOL), 0)
                       INTO V_QTPREVITMFORNOL
                       FROM GRSITEMAGENDAOL
                      WHERE CDFORNECED     = P_CDFORNECED
                        AND CDPRODUTO      = C_ITEM.CDPRODUTO
                        AND CDMARCA        = C_ITEM.CDMARCA
                        AND DTENTREGAGENDA  BETWEEN C_ITEM_AVG.DTPROGENT AND V_DTENTREGANT;

                     V_QTENTREGAGENDA  := V_QTPROGENTAF;
                     V_QTPROGITMFORNOL := 0;
                     IF V_QTPOSESTOL > 0 THEN
                        IF V_QTPOSESTOL >= V_QTPROGENTAF THEN
                           V_QTPROGITMFORNOL := V_QTPROGENTAF;
                           V_QTPOSESTOL      := V_QTPOSESTOL - V_QTPROGENTAF;
                        END IF;
                     END IF;
                     IF V_QTPOSESTOL < 0 THEN
                        V_QTPOSESTOL      := 0;
                     END IF;
                     V_DTENTREGANT := NULL;
                     SELECT MIN(USR_CARREGA_PERIFORNOL_FUN(P_CDFORNECED, C_ITEM_MARCA.CDFORNOL, DTDATA)) -1
                       INTO V_DTENTREGANT
                       FROM DATA
                      WHERE DTDATA > C_ITEM_AVG.DTPROGENT
                        AND USR_CARREGA_PERIFORNOL_FUN(P_CDFORNECED, C_ITEM_MARCA.CDFORNOL, DTDATA) <> C_ITEM_AVG.DTPROGENT;

                      IF V_DTENTREGANT < C_ITEM_AVG.DTPROGENT THEN
                         V_DTENTREGANT :=  C_ITEM_AVG.DTPROGENT;
                      END IF;
                       SELECT NVL(SUM(QTPROGENTAF), 0)
                         INTO V_QTAFPERIODO
                         FROM AUTOFORNE A, ITEMAUTF I
                        WHERE A.CDFORNECED  = P_CDFORNECED
                          AND I.CDFILDEST   = A.CDFILDEST
                          AND I.CDFILLANC   = A.CDFILLANC
                          AND I.NRAUTOFORN  = A.NRAUTOFORN
                          AND I.CDMARCA     = C_ITEM_MARCA.CDMARCA
                          AND I.CDPRODUTO   = C_ITEM.CDPRODUTO
                          AND I.DTPROGENTAF BETWEEN C_ITEM_AVG.DTPROGENT AND V_DTENTREGANT;
                     V_QTENTREGAGENDA := V_QTENTREGAGENDA + V_QTAFPERIODO; /*VERIFICAR TAMBM - V_QTPREVITMFORNOL*/
                     IF V_QTENTREGAGENDA > 0 THEN
                        BEGIN
                           INSERT
                             INTO GRSITEMAGENDAOL(NRAGENDAOL, CDFORNECED, CDFORNOL, CDPRODUTO, CDMARCA, DTENTREGAGENDA,
                                                  VRPREUNIAGENDA, QTPREVITMFORNOL, QTPROGITMFORNOL, QTDISPOFORNOL, QTESTOQFORNOL)
                           VALUES (P_NRAGENDAOL, P_CDFORNECED, C_ITEM_MARCA.CDFORNOL, C_ITEM.CDPRODUTO, C_ITEM_MARCA.CDMARCA, C_ITEM_AVG.DTPROGENT,
                                   C_ITEM_MARCA.VRPRECUNIITM, V_QTENTREGAGENDA, V_QTPROGITMFORNOL, C_ITEM_MARCA.QTDISPOFORNOL, V_QTESTOQUE);
                        EXCEPTION
                           WHEN OTHERS THEN
                              UPDATE GRSITEMAGENDAOL
                                 SET QTPREVITMFORNOL = QTPREVITMFORNOL+V_QTENTREGAGENDA,
                                     QTPROGITMFORNOL = QTPROGITMFORNOL+V_QTPROGITMFORNOL,
                                     QTDISPOFORNOL   = C_ITEM_MARCA.QTDISPOFORNOL,
                                     QTESTOQFORNOL   = V_QTESTOQUE
                               WHERE NRAGENDAOL     = P_NRAGENDAOL
                                 AND CDFORNECED     = P_CDFORNECED
                                 AND CDFORNOL       = C_ITEM_MARCA.CDFORNOL
                                 AND CDPRODUTO      = C_ITEM.CDPRODUTO
                                 AND CDMARCA        = C_ITEM_MARCA.CDMARCA
                                 AND DTENTREGAGENDA = C_ITEM_AVG.DTPROGENT;
                        END;
                        P_ROWSAFFECT := 'S';
                     END IF;
                  END LOOP;
               END  IF;
            END LOOP;
         END LOOP;
      END IF;
   END IF;
   IF P_ROWSAFFECT = 'N' THEN
      DELETE
        FROM GRSAGENDAOL
       WHERE NRAGENDAOL = P_NRAGENDAOL
         AND CDFORNECED = P_CDFORNECED;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_NECESSIDADE_DE_AGENDA_OL','5.42.XXX'); END;
/
