import { Http, IDictionary } from '@zeedhi/core';
import { ECharts } from '@zeedhi/zd-echarts';

export class DashboardController {
  public visibilidade: boolean = true;

  public currentRow: any = {};

  get visibilidadeDoFrame() {
    return !this.visibilidade;
  }

  public async dataBaseChartPie({ component }: { component: ECharts }) {
    await Http.get('/dataBaseChartPie').then((response: IDictionary) => {
      const newOptions = { ...component.options };
      if (response.data.length) {
        response.data.forEach((dados: IDictionary) => {
          const dado = {
            name: dados.NMATIVIDADE,
            value: dados.QUANTIDADE,
            itemStyle: {
              color: dados.DSCORIDATIVIDADE,
            },
          };
          newOptions.series[0].data.push(dado);
        });
        component.setOption(newOptions);
      } else {
        const dado = {
          name: 'Não há dados',
          value: 100,
          itemStyle: {
            color: '#57737a',
          },
        };
        newOptions.series[0].data.push(dado);
        component.setOption(newOptions);
      }
    });
  }
}
